=== debian/changelog ===
sdb (1.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch to libreadline8. Closes: #932638.
  * Bump debhelper to v9.

 -- Matthias Klose <doko@debian.org>  Thu, 25 Jul 2019 22:42:04 +0200

sdb (1.2-2) unstable; urgency=medium

  * [d1c8afe] The future arrived a long time ago - use langversion:Latest
    (Closes: #921902)

 -- Jo Shields <joshield@microsoft.com>  Fri, 15 Feb 2019 14:09:22 -0500

sdb (1.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch to libreadline7. (Closes: #849069)

 -- Adrian Bunk <bunk@debian.org>  Mon, 16 Jan 2017 01:14:02 +0200

sdb (1.2-1) unstable; urgency=low

  * Initial release

 -- Jo Shields <directhex@apebox.org>  Fri, 07 Feb 2014 11:32:52 +0000
