=== debian/control ===
Source: sdb
Section: cli-mono
Priority: extra
Maintainer: Jo Shields <directhex@apebox.org>
Build-Depends: debhelper (>= 9~), cli-common-dev (>= 0.8~), mono-devel (>= 3.0), libicsharpcode-nrefactory-cil-dev, libmono-debugger-libs-cil-dev, libmono-cecil-cil-dev, libreadline-dev (>= 8), libreadline-dev (<< 9)
Standards-Version: 4.4.0
Homepage: https://github.com/mono/sdb
Vcs-Git: git://git.debian.org/git/pkg-mono/packages/sdb.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-mono/packages/sdb.git;a=summary

Package: sdb
Architecture: all
Depends: ${cli:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: a command line client for Mono's soft debugger
 SDB is a command line client for Mono's soft debugger, a cooperative 
 debugger that is part of the Mono VM. It tries to be similar in 
 command syntax to tools such as GDB and LLDB.
