=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

override_dh_clean:
	rm -fr dep/

override_dh_auto_build:
	mkdir -p dep/
	dh_auto_build
	rm bin/Mono.Cecil.Pdb*
	rm bin/Mono.Cecil.Rocks*

override_dh_auto_test:

%:
	dh $@ --with cli
